package programs.rbts;

import programs.nodes.NodeRB;
import programs.nodes.NodeRB.Color;
import templates.heap.RBTTemplate;

public class RbtDelete {

	private NodeRB transplant(NodeRB root, NodeRB u, NodeRB v) {
		if (u.parent == null)
			root = v;
		else if (u == u.parent.left)
			u.parent.left = v;
		else
			u.parent.right = v;
		v.parent = u.parent;
		return root;
	}

	private NodeRB findMin(NodeRB root) {
		if (root == null || root.left == null)
			return root;
		else
			return findMin(root.left);
	}

	private NodeRB leftRotate(NodeRB root, NodeRB x) {
		NodeRB y = x.right;
		x.right = y.left;
		if (y.left != null)
			y.left.parent = x;
		y.parent = x.parent;
		if (x.parent == null)
			root = y;
		else if (x == x.parent.left)
			x.parent.left = y;
		else
			x.parent.right = y;
		y.left = x;
		x.parent = y;
		return root;
	}

	private NodeRB rightRotate(NodeRB root, NodeRB x) {
		NodeRB y = x.left;
		x.left = y.right;
		if (y.right != null)
			y.right.parent = x;
		y.parent = x.parent;
		if (x.parent == null)
			root = y;
		else if (x == x.parent.right)
			x.parent.right = y;
		else
			x.parent.left = y;
		y.right = x;
		x.parent = y;
		return root;
	}

	private NodeRB fixDelete(NodeRB root, NodeRB x) {
		if (x == root || x.color == Color.RED) {
			x.color = Color.BLACK;
			return root;
		} else {
			if (x == x.parent.left) {
				NodeRB w = x.parent.right;
				if (w.color == Color.RED) {
					w.color = Color.BLACK;
					x.parent.color = Color.RED;
					leftRotate(root, x.parent);
					w = x.parent.right;
				}
				if (w.left.color == Color.BLACK && w.right.color == Color.BLACK) {
					w.color = Color.RED;
					root = fixDelete(root, x.parent);
				} else {
					if (w.right.color == Color.BLACK) {
						w.left.color = Color.BLACK;
						w.color = Color.RED;
						rightRotate(root, w);
						w = x.parent.right;
					}
					w.color = x.parent.color;
					x.parent.color = Color.BLACK;
					w.right.color = Color.BLACK;
					leftRotate(root, x.parent);
					root = fixDelete(root, root);
				}
			} else {
				NodeRB w = x.parent.left;
				if (w.color == Color.RED) {
					w.color = Color.BLACK;
					x.parent.color = Color.RED;
					rightRotate(root, x.parent);
					w = x.parent.left;
				}
				if (w.left.color == Color.BLACK && w.right.color == Color.BLACK) {
					w.color = Color.RED;
					root = fixDelete(root, x.parent);
				} else {
					if (w.left.color == Color.BLACK) {
						w.right.color = Color.BLACK;
						w.color = Color.RED;
						leftRotate(root, w);
						w = x.parent.left;
					}
					w.color = x.parent.color;
					x.parent.color = Color.BLACK;
					w.left.color = Color.BLACK;
					rightRotate(root, x.parent);
					root = fixDelete(root, root);
				}
			}
			return root;
		}
	}

	private NodeRB delete(NodeRB root, NodeRB z) {
		NodeRB y = z;
		NodeRB x = null;
		Color origColor = y.color;
		if (z.left == null) {
			x = z.right;
			transplant(root, z, z.right);
		} else if (z.right == null) {
			x = z.left;
			transplant(root, z, z.left);
		} else {
			y = findMin(z.right);
			origColor = y.color;
			x = y.right;
			if (y.parent == z)
				x.parent = y;
			else {
				transplant(root, y, y.right);
				y.right = z.right;
				y.right.parent = y;
			}
			transplant(root, z, y);
			y.left = z.left;
			y.left.parent = y;
			y.color = z.color;
		}
		if (origColor == Color.BLACK)
			root = fixDelete(root, x);
		return root;
	}

	private NodeRB delete(NodeRB root, NodeRB z, int key) {
		if (z.data == key)
			return delete(root, z);
		else if (z.data < key)
			return delete(root, z.right, key);
		else
			return delete(root, z.left, key);
	}

	private void main1(NodeRB root, int i) {
		// pre = root::rbt()
		root = delete(root, root, i);
		assert (new RBTTemplate()).check(root).res == 1;
	}

}


/*
Failed as use aux functions
 */
