package programs.dlls;

import programs.nodes.DataStructureFactory;
import programs.nodes.NodeDll;
import templates.heap.DllTemplate;
import templates.*;
import templates.heap.*;
import templates.pure.*;
import templates.bag.*;

public class DllAppend {

	private NodeDll append(NodeDll x, NodeDll y) throws Exception {
		if (x == null)
			return y;
		if (y == null)
			return x;
		else if (x.next == null) {
			x.next = y;
			if (y.prev != null)
				throw new Exception();
			else
				y.prev = x;
			return x;
		} else {
			append(x.next, y);
			return x;
		}
	}

	//    private void append(NodeDll x, NodeDll y) throws Exception {
	//        if (x.next != null)
	//            append(x.next, y);
	//        else {
	//            x.next = y;
	//            y.prev = x;
	//        }
	//    }

    private boolean check(NodeDll prev, NodeDll x) {
        if (x == null)
            return true;
        else if (x.prev != prev)
            return false;
        else
            return check(x, x.next);
    }

    public void main1(NodeDll x, NodeDll y) throws Exception {
		// pre : x::dll() * y::dll()
        check(null, x);
		// inv : x::dll() * y::dll()
        check(null, y);
		// inv : x::dll() * y::dll()
        x = append(x, y);
		// post : x::dll()
        assert (new DllTemplate()).check(x).res == 1;
    }
}

// with simplified version, inv: x::dll() * y::dll() && x->Node() * y->Node() <==> x::dll() * y::dll() && x != null && y != null && x != y
