package programs.sortlls;

import programs.nodes.DataStructureFactory;
import programs.nodes.NodeSll;
import templates.heap.SortllTemplate;

public class SortllInsert {

    private NodeSll insert(NodeSll x, int i) {
        if (x == null)
            return new NodeSll(i, null);
        else if (x.data > i) {
            NodeSll z = new NodeSll(i, null);
            z.next = x;
            return z;
        } else if (x.next != null && x.next.data > i) {
            NodeSll z = new NodeSll(i, null);
            z.next = x.next;
            x.next = z;
            return x;
        } else {
            x.next = insert(x.next, i);
            return x;
        }
    }

    private boolean check(NodeSll x) {
        if (x == null)
            return true;
        else if (x.next != null && x.next.data < x.data)
            return false;
        else
            return check(x.next);
    }

    public void main1(NodeSll x, int i) {
		// pre: sortll(x)
        check(x);
		// inv: sortll(x)
        x = insert(x, i);
        assert (new SortllTemplate()).check(x).res == 1;
    }

}
